
# PYDEEPAN: Python based code for Deep Learning Stuff on Computer Animation


## Howto to code

### Anaconda: installation
curl -O https://repo.continuum.io/archive/Anaconda3-5.0.1-Linux-x86_64.sh
sh ./Anaconda3-5.0.1-Linux-x86_64.sh

### Anaconda: update
conda update -n base -c defaults conda

### Creation the environment
conda env create -f environment.yml
or
conda create --name py-deepan

### Conda activate
conda activate py-deepan

### git clone
git clone https://ucacaxm@git.renater.fr/authscm/ucacaxm/git/deepan/deepan.git

### Visual Code: 
Open the workspace file 'deepan.code-workspace' from the home dir of DeepAN



### PYTHONPATH and env variables
PYTHONPATH has to be set to the home of Deepan, for instance D:\alex\src\Deepan.gitrenater
or
export PYTHONPATH="/data/ameyer/





## Overview of the code / Directories

* math: base class for math (Vec3, Quaternion, Transform)
* chara: Character Animation 
* latent: spaces build by training of neural networks (NN). The main part of this code. 
* preprocess: script to convert standard dataset into the same skeleton and into an NPZ called HPA=Holden Positional Format
* viewer:  script to visualize animations
* recognition: try to improve state of the art recognition rate of expression (initialy based on the work of Florent (Master intership))
* script: script (bash) to launch computation on in2p3, TD8. ( or CNRS-cluster?)




## Preprocessing

Many available dataset of animations has been preprocessed to produce unified animations, often HPA=Holden Positional Animation
These preprocesses are based on the Holden's code, which is used only in this step.

See preprocess/README.md





### jupyter notebook
ssh td8
cd /data/ameyer/
jupyter notebook --ip 0.0.0.0



## Renforcement Learning
I) Des lectures

1) un bon cours : A Free course in Deep Reinforcement Learning from beginner to expert.
https://simoninithomas.github.io/Deep_reinforcement_learning_Course/

Le chapitre sur Qlearning : (avant de regarder le Deep Q Learning) :
https://medium.freecodecamp.org/diving-deeper-into-reinforcement-learning-with-q-learning-c18d0db58efe


2) An introduction to Q-Learning: reinforcement learning
https://medium.freecodecamp.org/an-introduction-to-q-learning-reinforcement-learning-14ac0b4493cc


3) A Beginner's Guide to Deep Reinforcement Learning
https://skymind.ai/wiki/deep-reinforcement-learning



4) ML-Agent / Flappy Bird : ce tuto utilise du code de RL (reenforcement Learning) du 4e point ML-Agent
    Teaching AI to play Flappy Bird with Unity
https://becominghuman.ai/teaching-ai-to-play-flappy-bird-with-unity-70f7b661663d


II) *** ML-Agent ***
4)    ML-Agent : Unity et Apprentissage Machine
https://unity3d.com/fr/machine-learning

A regarder dans cet ordre :
* install
https://github.com/Unity-Technologies/ml-agents/blob/master/docs/Installation.md

* Refaire un apprentissage d'un mini jeu existant dans mlAgent
https://github.com/Unity-Technologies/ml-agents/blob/master/docs/Basic-Guide.md

* Créer un nouvel environnement
https://github.com/Unity-Technologies/ml-agents/blob/master/docs/Learning-Environment-Create-New.md
