# Send HPA animation to Unity through mlAgent communication system
#
#
# TODO in Unity
# Create a sphere (or a character)
#


import sys
import os
import numpy as np
from mlagents.envs.environment import UnityEnvironment

from pydeepan import dataset
from pydeepan.motion.Quaternions import Quaternions

def clamp(a,m,M):
    return min( max(a,m), M)


def fillAction( anims, obs):
    animId = clamp( int(obs[0]), 0, anims.shape[0] )
    frameId = clamp( int(obs[1]), 0, anims.shape[1] )
    print("animId=%d frameId=%d" % (animId, frameId) )
    action = np.zeros( 75 )
    for i in range(73):
        action[i] = anims[animId, frameId, i]
    action[73] = anims.shape[0]
    action[74] = anims.shape[1]
    return action


if __name__ == '__main__':
    cwd = os.getcwd()
    print("cwd=",cwd)
    #env = UnityEnvironment(file_name="../../build-envs/Deepan", worker_id=0, seed=217) # ../../build-envs/RollerBall/RollerBall.exe should exist
    #env = UnityEnvironment(file_name="./build-envs/Deepan", worker_id=0, seed=217) # ../../build-envs/RollerBall/RollerBall.exe should exist
    env = UnityEnvironment(file_name=None, worker_id=0, seed=217) # None => has to press run in the Unity editor

    brain = env.brains['PythonBrain']       # See brain name in the Unity Editor
    print("brain="+str(brain))
    print("number of agents=" + str(len(brain.vector_action_space_size)))
    print("action space type="+str(brain.vector_action_space_type))
    print("action space size="+str(brain.vector_action_space_size))
    print("observation space size=" + str(brain.vector_observation_space_size))
    print("=================================")

    #database = np.load( dataset.path_processed + 'data_cmu.npz')['clips']
    database = np.load( dataset.dir_anims_processed_npz + 'data_hdm05.npz')['clips']
    #database = np.load( dataset.path_processed + 'data_edin_locomotion.npz')['clips']
    print("database shape="+str(database.shape))



    agentId = 0            # assume only one agent
    stop = False
    info = env.reset()
    while not stop:
        #print("info=",str(info))
        #print(str(info))
        brainInfo = info['PythonBrain']
        obs = brainInfo.vector_observations
            #print(  "size="+str(len(brainInfo.vector_observations))+ " "+ str(len(brainInfo.rewards)) + " "+str(len(brainInfo.local_done))
            #        + "  values="+str(brainInfo.vector_observations)+ " "+ str(brainInfo.rewards) + " "+str(brainInfo.local_done))

        action = fillAction(database, obs[agentId])
        info = env.step(action)
        brainInfo = info['PythonBrain']
        stop = brainInfo.local_done[agentId]

    print("Stop")
    env.close()

